/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { AccountEmails } from '../models/accountEmails';
import { DeletedResponse } from '../models/deletedResponse';
import { Configuration } from '../configuration';
import { AccountEmailsServiceInterface } from './accountEmails.serviceInterface';
export declare class AccountEmailsService implements AccountEmailsServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one AccountEmail.
     * Add one AccountEmail.
     * @param accountEmail
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addAccountEmails(accountEmail: AccountEmails, observe?: 'body', reportProgress?: boolean): Observable<AccountEmails>;
    addAccountEmails(accountEmail: AccountEmails, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AccountEmails>>;
    addAccountEmails(accountEmail: AccountEmails, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AccountEmails>>;
    /**
     * Delete one AccountEmail.
     * Delete one AccountEmail.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteAccountEmail(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteAccountEmail(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteAccountEmail(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one AccountEmail.
     * Edit one AccountEmail.
     * @param accountEmail
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editAccountEmail(accountEmail: AccountEmails, observe?: 'body', reportProgress?: boolean): Observable<AccountEmails>;
    editAccountEmail(accountEmail: AccountEmails, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AccountEmails>>;
    editAccountEmail(accountEmail: AccountEmails, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AccountEmails>>;
    /**
     * Get one AccountEmail.
     * Get one AccountEmail.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getAccountEmailById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'body', reportProgress?: boolean): Observable<AccountEmails>;
    getAccountEmailById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AccountEmails>>;
    getAccountEmailById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AccountEmails>>;
    /**
     * Get all AccountEmails.
     * Get all AccountEmails.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getAccountEmails(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getAccountEmails(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getAccountEmails(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
}
