/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Accounts } from '../models/accounts';
import { DeletedResponse } from '../models/deletedResponse';
import { Configuration } from '../configuration';
import { AccountsServiceInterface } from './accounts.serviceInterface';
export declare class AccountsService implements AccountsServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one Account.
     * Add one Account.
     * @param account
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addAccount(account: Accounts, observe?: 'body', reportProgress?: boolean): Observable<Accounts>;
    addAccount(account: Accounts, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Accounts>>;
    addAccount(account: Accounts, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Accounts>>;
    /**
     * Delete one Account.
     * Delete one Account.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteAccount(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteAccount(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteAccount(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one Account.
     * Edit one Account.
     * @param account
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editAccount(account: Accounts, observe?: 'body', reportProgress?: boolean): Observable<Accounts>;
    editAccount(account: Accounts, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Accounts>>;
    editAccount(account: Accounts, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Accounts>>;
    /**
     * Get one Account.
     * Get one Account.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getAccountById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'body', reportProgress?: boolean): Observable<Accounts>;
    getAccountById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Accounts>>;
    getAccountById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Accounts>>;
    /**
     * Get all Accounts.
     * Get all Accounts.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getAccounts(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getAccounts(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getAccounts(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
}
