/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Carriers } from '../models/carriers';
import { DeletedResponse } from '../models/deletedResponse';
import { Configuration } from '../configuration';
import { CarriersServiceInterface } from './carriers.serviceInterface';
export declare class CarriersService implements CarriersServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one carrier.
     * Add one carrier.
     * @param carrier
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addCarrier(carrier: Carriers, observe?: 'body', reportProgress?: boolean): Observable<Carriers>;
    addCarrier(carrier: Carriers, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Carriers>>;
    addCarrier(carrier: Carriers, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Carriers>>;
    /**
     * Delete one carrier.
     * Delete one carrier.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteCarrier(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteCarrier(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteCarrier(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one carrier.
     * Edit one carrier.
     * @param carrier
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editCarrier(carrier: Carriers, observe?: 'body', reportProgress?: boolean): Observable<Carriers>;
    editCarrier(carrier: Carriers, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Carriers>>;
    editCarrier(carrier: Carriers, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Carriers>>;
    /**
     * Get one carrier.
     * Get one carrier.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getCarrierById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'body', reportProgress?: boolean): Observable<Carriers>;
    getCarrierById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Carriers>>;
    getCarrierById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Carriers>>;
    /**
     * Get all carriers.
     * Get all carriers.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getCarriers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getCarriers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getCarriers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
}
