/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { Deliveries } from '../models/deliveries';
import { Configuration } from '../configuration';
import { DeliveriesServiceInterface } from './deliveries.serviceInterface';
export declare class DeliveriesService implements DeliveriesServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one Delivery.
     * Add one Delivery.
     * @param delivery
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addDelivery(delivery: Deliveries, observe?: 'body', reportProgress?: boolean): Observable<Deliveries>;
    addDelivery(delivery: Deliveries, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Deliveries>>;
    addDelivery(delivery: Deliveries, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Deliveries>>;
    /**
     * Delete one Delivery.
     * Delete one Delivery.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteDelivery(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteDelivery(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteDelivery(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one Delivery.
     * Edit one Delivery.
     * @param delivery
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editDelivery(delivery: Deliveries, observe?: 'body', reportProgress?: boolean): Observable<Deliveries>;
    editDelivery(delivery: Deliveries, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Deliveries>>;
    editDelivery(delivery: Deliveries, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Deliveries>>;
    /**
     * Get all Deliveries.
     * Get all Deliveries.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getDeliveries(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getDeliveries(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getDeliveries(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    /**
     * Get one Delivery.
     * Get one Delivery.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getDeliveryById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<Deliveries>;
    getDeliveryById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Deliveries>>;
    getDeliveryById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Deliveries>>;
}
