/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Data } from '../models/data';
import { LoginObject } from '../models/loginObject';
import { Configuration } from '../configuration';
import { EmailsServiceInterface } from './emails.serviceInterface';
export declare class EmailsService implements EmailsServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * send verification email to user
     * Send verification email to user
     * @param data
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    sendEmail(data: Data, observe?: 'body', reportProgress?: boolean): Observable<any>;
    sendEmail(data: Data, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    sendEmail(data: Data, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    /**
     * Verify user&#39;s email
     *
     * @param token Access token
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    verifyEmail(token: string, observe?: 'body', reportProgress?: boolean): Observable<LoginObject>;
    verifyEmail(token: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<LoginObject>>;
    verifyEmail(token: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<LoginObject>>;
}
