/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { HandedOvers } from '../models/handedOvers';
import { Configuration } from '../configuration';
import { HandedOversServiceInterface } from './handedOvers.serviceInterface';
export declare class HandedOversService implements HandedOversServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one HandedOver.
     * Add one HandedOver.
     * @param handedOver
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addHandedOver(handedOver: HandedOvers, observe?: 'body', reportProgress?: boolean): Observable<HandedOvers>;
    addHandedOver(handedOver: HandedOvers, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<HandedOvers>>;
    addHandedOver(handedOver: HandedOvers, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<HandedOvers>>;
    /**
     * Delete one HandedOver.
     * Delete one HandedOver.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteHandedOver(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteHandedOver(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteHandedOver(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one HandedOver.
     * Edit one HandedOver.
     * @param handedOver
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editHandedOver(handedOver: HandedOvers, observe?: 'body', reportProgress?: boolean): Observable<HandedOvers>;
    editHandedOver(handedOver: HandedOvers, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<HandedOvers>>;
    editHandedOver(handedOver: HandedOvers, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<HandedOvers>>;
    /**
     * Get one HandedOver.
     * Get one HandedOver.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getHandedOverById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<HandedOvers>;
    getHandedOverById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<HandedOvers>>;
    getHandedOverById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<HandedOvers>>;
    /**
     * Get all HandedOvers.
     * Get all HandedOvers.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getHandedOvers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getHandedOvers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getHandedOvers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
}
