/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { JourneyDeliveries } from '../models/journeyDeliveries';
import { Configuration } from '../configuration';
import { JourneyDeliveriesServiceInterface } from './journeyDeliveries.serviceInterface';
export declare class JourneyDeliveriesService implements JourneyDeliveriesServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one JourneyDelivery.
     * Add one JourneyDelivery.
     * @param journeyDelivery
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addJourneyDelivery(journeyDelivery: JourneyDeliveries, observe?: 'body', reportProgress?: boolean): Observable<JourneyDeliveries>;
    addJourneyDelivery(journeyDelivery: JourneyDeliveries, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<JourneyDeliveries>>;
    addJourneyDelivery(journeyDelivery: JourneyDeliveries, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<JourneyDeliveries>>;
    /**
     * Delete one JourneyDelivery.
     * Delete one JourneyDelivery.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteJourneyDelivery(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteJourneyDelivery(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteJourneyDelivery(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one JourneyDelivery.
     * Edit one JourneyDelivery.
     * @param journeyDelivery
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editJourneyDelivery(journeyDelivery: JourneyDeliveries, observe?: 'body', reportProgress?: boolean): Observable<JourneyDeliveries>;
    editJourneyDelivery(journeyDelivery: JourneyDeliveries, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<JourneyDeliveries>>;
    editJourneyDelivery(journeyDelivery: JourneyDeliveries, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<JourneyDeliveries>>;
    /**
     * Get all JourneyDeliveries.
     * Get all JourneyDeliveries.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getJourneyDeliveries(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getJourneyDeliveries(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getJourneyDeliveries(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    /**
     * Get one JourneyDelivery.
     * Get one JourneyDelivery.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getJourneyDeliveryById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<JourneyDeliveries>;
    getJourneyDeliveryById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<JourneyDeliveries>>;
    getJourneyDeliveryById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<JourneyDeliveries>>;
}
