/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { Journeys } from '../models/journeys';
import { Configuration } from '../configuration';
import { JourneysServiceInterface } from './journeys.serviceInterface';
export declare class JourneysService implements JourneysServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one Journey.
     * Add one Journey.
     * @param journey
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addJourney(journey: Journeys, observe?: 'body', reportProgress?: boolean): Observable<Journeys>;
    addJourney(journey: Journeys, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Journeys>>;
    addJourney(journey: Journeys, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Journeys>>;
    /**
     * Delete one Journey.
     * Delete one Journey.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteJourney(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteJourney(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteJourney(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one Journey.
     * Edit one Journey.
     * @param journey
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editJourney(journey: Journeys, observe?: 'body', reportProgress?: boolean): Observable<Journeys>;
    editJourney(journey: Journeys, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Journeys>>;
    editJourney(journey: Journeys, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Journeys>>;
    /**
     * Get one Journey.
     * Get one Journey.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getJourneyById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<Journeys>;
    getJourneyById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Journeys>>;
    getJourneyById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Journeys>>;
    /**
     * Get all Journeys.
     * Get all Journeys.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getJourneys(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getJourneys(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getJourneys(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
}
