/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { Journeys } from '../models/journeys';
import { Configuration } from '../configuration';
export interface JourneysServiceInterface {
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    /**
    * Add one Journey.
    * Add one Journey.
    * @param journey
    */
    addJourney(journey: Journeys, extraHttpRequestParams?: any): Observable<Journeys>;
    /**
    * Delete one Journey.
    * Delete one Journey.
    * @param id id to delete or search
    */
    deleteJourney(id: number, extraHttpRequestParams?: any): Observable<DeletedResponse>;
    /**
    * Edit one Journey.
    * Edit one Journey.
    * @param journey
    */
    editJourney(journey: Journeys, extraHttpRequestParams?: any): Observable<Journeys>;
    /**
    * Get one Journey.
    * Get one Journey.
    * @param id id to delete or search
    * @param deleted Get all, deleted, not deleted data. Default not deleted.
    * @param idUser id of user to get information only from it
    */
    getJourneyById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, extraHttpRequestParams?: any): Observable<Journeys>;
    /**
    * Get all Journeys.
    * Get all Journeys.
    * @param skip number of item to skip
    * @param limit max records to return
    * @param orderBy order by property.
    * @param filter filter data.
    * @param deleted Get all, deleted, not deleted data. Default not deleted.
    * @param metadata If metadata is needed (for pagination controls)
    * @param idUser id of user to get information only from it
    */
    getJourneys(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, extraHttpRequestParams?: any): Observable<any>;
}
