/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { Locations } from '../models/locations';
import { Configuration } from '../configuration';
import { LocationsServiceInterface } from './locations.serviceInterface';
export declare class LocationsService implements LocationsServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one Location.
     * Add one Location.
     * @param location
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addLocation(location: Locations, observe?: 'body', reportProgress?: boolean): Observable<Locations>;
    addLocation(location: Locations, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Locations>>;
    addLocation(location: Locations, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Locations>>;
    /**
     * Delete one Location.
     * Delete one Location.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteLocation(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteLocation(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteLocation(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one Location.
     * Edit one Location.
     * @param location
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editLocation(location: Locations, observe?: 'body', reportProgress?: boolean): Observable<Locations>;
    editLocation(location: Locations, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Locations>>;
    editLocation(location: Locations, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Locations>>;
    /**
     * Get one Location.
     * Get one Location.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getLocationById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'body', reportProgress?: boolean): Observable<Locations>;
    getLocationById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Locations>>;
    getLocationById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Locations>>;
    /**
     * Get all Locations.
     * Get all Locations.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getLocations(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getLocations(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getLocations(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
}
