/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { Memberships } from '../models/memberships';
import { Configuration } from '../configuration';
import { MembershipsServiceInterface } from './memberships.serviceInterface';
export declare class MembershipsService implements MembershipsServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one Membership.
     * Add one Membership.
     * @param membership
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addMembership(membership: Memberships, observe?: 'body', reportProgress?: boolean): Observable<Memberships>;
    addMembership(membership: Memberships, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Memberships>>;
    addMembership(membership: Memberships, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Memberships>>;
    /**
     * Delete one Membership.
     * Delete one Membership.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteMembership(id: number, observe?: 'body', reportProgress?: boolean): Observable<DeletedResponse>;
    deleteMembership(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DeletedResponse>>;
    deleteMembership(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DeletedResponse>>;
    /**
     * Edit one Membership.
     * Edit one Membership.
     * @param membership
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editMembership(membership: Memberships, observe?: 'body', reportProgress?: boolean): Observable<Memberships>;
    editMembership(membership: Memberships, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Memberships>>;
    editMembership(membership: Memberships, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Memberships>>;
    /**
     * Get all Memberships.
     * Get all Memberships.
     * @param skip number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filter filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getMemberships(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<any>;
    getMemberships(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    getMemberships(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    /**
     * Get one Membership.
     * Get one Membership.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param idUser id of user to get information only from it
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getMembershipsById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'body', reportProgress?: boolean): Observable<Memberships>;
    getMembershipsById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Memberships>>;
    getMembershipsById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Memberships>>;
}
