/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { Memberships } from '../models/memberships';
import { Configuration } from '../configuration';
export interface MembershipsServiceInterface {
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    /**
    * Add one Membership.
    * Add one Membership.
    * @param membership
    */
    addMembership(membership: Memberships, extraHttpRequestParams?: any): Observable<Memberships>;
    /**
    * Delete one Membership.
    * Delete one Membership.
    * @param id id to delete or search
    */
    deleteMembership(id: number, extraHttpRequestParams?: any): Observable<DeletedResponse>;
    /**
    * Edit one Membership.
    * Edit one Membership.
    * @param membership
    */
    editMembership(membership: Memberships, extraHttpRequestParams?: any): Observable<Memberships>;
    /**
    * Get all Memberships.
    * Get all Memberships.
    * @param skip number of item to skip
    * @param limit max records to return
    * @param orderBy order by property.
    * @param filter filter data.
    * @param deleted Get all, deleted, not deleted data. Default not deleted.
    * @param metadata If metadata is needed (for pagination controls)
    * @param idUser id of user to get information only from it
    */
    getMemberships(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', metadata?: boolean, idUser?: number, extraHttpRequestParams?: any): Observable<any>;
    /**
    * Get one Membership.
    * Get one Membership.
    * @param id id to delete or search
    * @param deleted Get all, deleted, not deleted data. Default not deleted.
    * @param idUser id of user to get information only from it
    */
    getMembershipsById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', idUser?: number, extraHttpRequestParams?: any): Observable<Memberships>;
}
