/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.1
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Configuration } from '../configuration';
import { PasswordsServiceInterface } from './passwords.serviceInterface';
export declare class PasswordsService implements PasswordsServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Change user password by providing old one.
     *
     * @param oldPassword Old Password
     * @param newPassword New Password
     * @param userId User to change password. Only for admin users.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    changePassword(oldPassword: string, newPassword: string, userId?: string, observe?: 'body', reportProgress?: boolean): Observable<any>;
    changePassword(oldPassword: string, newPassword: string, userId?: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    changePassword(oldPassword: string, newPassword: string, userId?: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    /**
     * Change user password with a token.
     *
     * @param token The access token
     * @param password The access token
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    changePasswordWithToken(token: string, password: string, observe?: 'body', reportProgress?: boolean): Observable<any>;
    changePasswordWithToken(token: string, password: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    changePasswordWithToken(token: string, password: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    /**
     * Request a change of password by email.
     *
     * @param email User&#39;s email.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    requestPassword(email: string, observe?: 'body', reportProgress?: boolean): Observable<any>;
    requestPassword(email: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    requestPassword(email: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
}
